/*
	GnuJSP Toolkit - useful classes for JSP and servlet development
	Copyright (C) 1998, Vincent Partington <vincentp@xs4all.nl>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

package	nl.nmg.servlet;

/**
 * The URLDecoder class contains a utility method for decoding
 * a string in the MIME format called "<CODE>x-www-form-urlencoded</CODE>".
 *
 * @see java.net.URLEncoder
 */
public class URLDecoder {
	/**
	 * No public constructor
	 */
	private URLDecoder ()
	{
	}

	/**
	 * Decodes a urlencoded string into a regular string.
	 *
	 * @param val the <CODE>String</CODE> to decode.
	 * @return the decoded <CODE>String</CODE>.
	 */
	public static String decode(String val) {        
        StringBuffer	buf = new StringBuffer(val.length() + 8);
        char			c;

		for (int i = 0; i < val.length(); i++) {
			c = val.charAt(i);
			if(c == '%') {
				try {
					buf.append((char)Integer.parseInt(val.substring(i+1,i+3),16));
					i += 2;
					continue;
				} catch(Exception e) { }
			} else if(c == '+') {
				buf.append(' ');
				continue;
			}
 			buf.append(c);
		}
        return buf.toString();
	}
}
